#!/bin/sh

basename="$(basename "$0" || echo "$0")"

run() {
   command=$@
   # Uncommand the next line for debugging this script.
   #echo "$basename: Executing \"${command}\""
   ${command}
   status=$?
   if test $status -ne 0; then
      echo "$basename: Execution of \"${command}\" failed (exit status ${status})"
      echo "$basename: aborted (exit status ${status})"
      exit ${status}
   fi
}

run cd opensp
chmod -R +rw *
run libtoolize --copy --force
run chmod +x autoinit.sh
run ./autoinit.sh
export CXXFLAGS="-O3 -fPIC"
run ./configure --disable-doc-build
run make
export CXXFLAGS=""
run cd ..

run cp opensp/lib/.libs/libosp.a src
run make


# cd opensp
# ln -s `which libtool` libtool
# chmod -R +rw *
# aclocal
# autoheader
# automake --add-missing
# autoconf
# ./configure --disable-doc-build CXXFLAGS=-O3
# make
# cd ..
# 
# cp opensp/lib/.libs/libosp.a src
# make
