# Build a XPI file
#
# History : 
#   - 15/08/2004 creation 
#   - 24/10/2004 unix version
#

# set the var VERSION and change the RDF and JS file 
. ./version.sh

if [ "$1" = "WINDOWS" ]; then
  LIB_NAME=nstidy.dll 
  POSTFIX=win_$VERSION
else
  if [ `uname` = "Darwin" ]; then
    echo OS X version
    LIB_NAME=libnstidy.dylib
    POSTFIX=macos_$VERSION
  else
    LIB_NAME=libnstidy.so
    POSTFIX=linux_$VERSION
  fi
  mv xpi/install.js xpi/install.win
  cat xpi/install.win | sed -e "s/nstidy.dll/$LIB_NAME/" > xpi/install.js
  rm xpi/install.win
fi

# ---------------------------------------------------------------
# Common

rm tidy.jar
rm tidy_mozilla_$POSTFIX.xpi
rm tidy_firefox_$POSTFIX.xpi

rm xpi/components/nstidy.dll
rm xpi/components/libnstidy.so
rm xpi/components/libnstidy.dylib
rm xpi/components/nstidy.xpt

cd jar

zip -r ../tidy.jar *
cd ..
cp tidy.jar xpi/chrome/.

# ---------------------------------------------------------------
# Firefox

cp ../firefox/mozilla/dist/bin/components/$LIB_NAME xpi/components
cp ../firefox/mozilla/dist/bin/components/nstidy.xpt xpi/components

cd xpi
touch components/.autoreg
zip -r ../tidy_firefox_$POSTFIX.xpi *
cd ..

# For easing the installation and testing of the file
cp tidy_firefox_$POSTFIX.xpi tidy_firefox.xpi 

# ---------------------------------------------------------------

